/[gentoo-x86]/eclass/elisp.eclass
Gentoo

Diff of /eclass/elisp.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.19 Revision 1.34
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2008 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp.eclass,v 1.19 2007/07/02 06:19:18 opfer Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp.eclass,v 1.34 2008/09/19 08:12:48 ulm Exp $
4# 4#
5# Copyright 2007 Christian Faulhammer <opfer@gentoo.org>
6# Copyright 2002-2007 Matthew Kennedy <mkennedy@gentoo.org> 5# Copyright 2002-2003 Matthew Kennedy <mkennedy@gentoo.org>
7# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com> 6# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com>
7# Copyright 2007-2008 Christian Faulhammer <opfer@gentoo.org>
8# Copyright 2007 Ulrich Mueller <ulm@gentoo.org> 8# Copyright 2007-2008 Ulrich MΓΌller <ulm@gentoo.org>
9# 9#
10# @ECLASS: elisp.eclass
11# @MAINTAINER:
12# Feel free to contact the Emacs team through <emacs@gentoo.org> if you
13# have problems, suggestions or questions.
14# @BLURB: Eclass for Emacs Lisp packages
15# @DESCRIPTION:
16#
10# This eclass sets the site-lisp directory for emacs-related packages. 17# This eclass sets the site-lisp directory for Emacs-related packages.
11# 18#
12# Emacs support for other than pure elisp packages is handled by 19# Emacs support for other than pure elisp packages is handled by
13# elisp-common.eclass where you won't have a dependency on Emacs 20# elisp-common.eclass where you won't have a dependency on Emacs itself.
14# itself. All elisp-* functions are documented there. 21# All elisp-* functions are documented there.
15# 22#
16# Setting SIMPLE_ELISP=t in an ebuild means, that the package's source 23# If the package's source is a single (in whatever way) compressed elisp
17# is a single (in whatever way) compressed elisp file with the file name 24# file with the file name ${P}.el, then this eclass will move ${P}.el to
18# ${PN}-${PV}. The consequences: 25# ${PN}.el in src_unpack().
19# 26
20# 1.) ${S} is redefined 27# @ECLASS-VARIABLE: DOCS
21# 2.) ${PN}-${PV}.el is moved to ${PN} in the system. 28# @DESCRIPTION:
22#
23# SRC_URI should be set to wherever the primary app-emacs/ maintainer
24# keeps the local elisp mirror, since most app-emacs packages are
25# upstream as a single .el file.
26#
27# DOCS="blah.txt ChangeLog" is automatically used to install the given 29# DOCS="blah.txt ChangeLog" is automatically used to install the given
28# files by dodoc in src_install(). 30# files by dodoc in src_install().
29# 31
32# @ECLASS-VARIABLE: NEED_EMACS
33# @DESCRIPTION:
30# If you need anything different from Emacs 21, use the NEED_EMACS 34# If you need anything different from Emacs 21, use the NEED_EMACS
31# variable before inheriting elisp.eclass. Set it to the major version 35# variable before inheriting elisp.eclass. Set it to the major version
32# your package uses and the dependency will be adjusted. 36# your package uses and the dependency will be adjusted.
33 37
34inherit elisp-common versionator 38inherit elisp-common versionator
35 39
36VERSION=${NEED_EMACS:-21}
37DEPEND=">=virtual/emacs-${VERSION}" 40DEPEND=">=virtual/emacs-${NEED_EMACS:-21}"
41RDEPEND=">=virtual/emacs-${NEED_EMACS:-21}"
38IUSE="" 42IUSE=""
39 43
40if [ "${SIMPLE_ELISP}" = 't' ]; then
41 S="${WORKDIR}/"
42fi
43
44elisp_pkg_setup() { 44elisp_pkg_setup() {
45 local need_emacs=${NEED_EMACS:-21}
45 local emacs_version="$(elisp-emacs-version)" 46 local have_emacs=$(elisp-emacs-version)
46 if ! version_is_at_least "${VERSION}" "${emacs_version}"; then 47 if ! version_is_at_least "${need_emacs}" "${have_emacs}"; then
47 eerror "This package needs at least Emacs ${VERSION}." 48 eerror "This package needs at least Emacs ${need_emacs}."
48 eerror "Use \"eselect emacs\" to select the active version." 49 eerror "Use \"eselect emacs\" to select the active version."
49 die "Emacs version ${emacs_version} is too low." 50 die "Emacs version ${have_emacs} is too low."
50 fi 51 fi
51} 52}
52 53
53elisp_src_unpack() { 54elisp_src_unpack() {
54 unpack ${A} 55 [ -n "${A}" ] && unpack ${A}
55 if [ "${SIMPLE_ELISP}" = 't' ]; then 56 if [ -f ${P}.el ]; then
56 cd "${S}" && mv ${P}.el ${PN}.el 57 mv ${P}.el ${PN}.el || die "mv ${P}.el ${PN}.el failed"
57 fi 58 fi
58} 59}
59 60
60elisp_src_compile() { 61elisp_src_compile() {
61 elisp-compile *.el || die "elisp-compile failed" 62 elisp-compile *.el || die "elisp-compile failed"
62} 63}
63 64
64elisp_src_install() { 65elisp_src_install() {
65 elisp-install ${PN} *.el *.elc 66 elisp-install ${PN} *.el *.elc || die "elisp-install failed"
66 elisp-site-file-install "${FILESDIR}/${SITEFILE}" 67 elisp-site-file-install "${FILESDIR}/${SITEFILE}" \
68 || die "elisp-site-file-install failed"
67 if [ -n "${DOCS}" ]; then 69 if [ -n "${DOCS}" ]; then
68 dodoc ${DOCS} || die "dodoc failed" 70 dodoc ${DOCS} || die "dodoc failed"
69 fi 71 fi
70} 72}
71 73
75 77
76elisp_pkg_postrm() { 78elisp_pkg_postrm() {
77 elisp-site-regen 79 elisp-site-regen
78} 80}
79 81
82EXPORT_FUNCTIONS \
80EXPORT_FUNCTIONS src_unpack src_compile src_install 83 src_unpack src_compile src_install \
81EXPORT_FUNCTIONS pkg_setup pkg_postinst pkg_postrm 84 pkg_setup pkg_postinst pkg_postrm

Legend:
Removed from v.1.19  
changed lines
  Added in v.1.34

  ViewVC Help
Powered by ViewVC 1.1.20